/*
*/

#include "iodefine.h"
#include "uart.h"

void uart_init(void)
{
	// SCI1
	unsigned short temp;
	
	MSTPCR.BIT._SCI1=0;	// SCI1 W[Xgbv[h
	SCI1.SCR.BYTE=0;	// M֎~
	SCI1.SMR.BYTE=0;
	SCI1.SCMR.BYTE=0;

	SCI1.SMR.BIT.CKS=0;
	SCI1.BRR=15;		// rbg[g 64:9600bps 32:19200 19:31250 15:38400
	
	for (temp=0; temp<10000; temp++);	// 1rbgԈȏ҂

	SCI1.SCR.BIT.TE=1;	// M
	SCI1.SCR.BIT.RE=1;	// M
}

void putch(unsigned char a)
{
	while(SCI1.SSR.BIT.TDRE==0);	// Mobt@ɂȂ̂҂
	
	SCI1.TDR=a;
	SCI1.SSR.BIT.TDRE=0;	// Mobt@GveBtONA
}

void puts(char str[])
{
	unsigned int a=0;
	while(1)
	{
		if(str[a]==0) break;
		putch(str[a]);
		a++;
	}
}

unsigned char getch(void)
{
	if(SCI1.SSR.BIT.ORER==1)SCI1.SSR.BIT.ORER=0;	// MG[tOĂƎMȂ̂ŁAtONA
	if(SCI1.SSR.BIT.FER==1)SCI1.SSR.BIT.FER=0;		// iG[𖳎j
	if(SCI1.SSR.BIT.PER==1)SCI1.SSR.BIT.PER=0;
		
	while(SCI1.SSR.BIT.RDRF==0);	// M܂ő҂
	
	SCI1.SSR.BIT.RDRF=0;

	return SCI1.RDR;
}

// ȂɂM1Ԃ
unsigned char keyhit(void)
{
	return (unsigned char)SCI1.SSR.BIT.RDRF;
}

/*
void puthex(unsigned char a)
{
	putch(tochar((a&0xF0)>>4));
	putch(tochar(a&0x0F));
}

unsigned char tochar(unsigned char a)
{
	if(a<10) a=a+0x30;
	else a=a+0x41-10;
	return a;
}

void puthexshort(unsigned short a)
{
	puthex((a>>8)&0xFF);
	puthex((a&0xFF));
}

unsigned short getshort(void)
{
	unsigned short data;
	data =((unsigned short)getch()<<8);
	data+=((unsigned short)getch()   );
	return data;
}

void putshort(unsigned short data)
{
	putch((data>>8)&0xFF);
	putch((data   )&0xFF);
}

void putdecimal(unsigned short data)
{
	putch(tochar(data/10000));
	data=data%10000;
	putch(tochar(data/1000));
	data=data%1000;
	putch(tochar(data/100));
	data=data%100;
	putch(tochar(data/10));
	data=data%10;
	putch(tochar(data));
}
*/
