/*
2014N826 쐬
*/

#include <machine.h>
#include "typedefine.h"
#include "iodefine.h"


void HardwareSetup(void)
{
	/*
		OoX̐ݒ

H8S/2144̃AhoXh[h

000000 - 01FFFF ܂œ ROM

FFE080 - FFEFFF	3967byte
FFFF00 - FFFF7F  127byte  RAM

200000 - 21FFFF O SRAM 128kB

400000 - 800000 O FLASH ROM 512kB

	*/
	
	//MDCR.BIT.EXPE=1;		// g[h
	MDCR.BYTE=0x80;		// 1000 0000 bit7: 1:g[h
	SYSCR.BYTE=0x09;	// 0000 1001 bit0: 1:RAML
	STCR.BYTE=0x00;		// 0000 0000
	BSC.BCR.BYTE=0x97;	// 1001 0111 bit6: 1:O[hTCNƊOCgTCNAƂAAChTCN}
						//           bit5: 1:o[XgROM Cl[u
						//           bit4: 1:o[XgTCNZNg1
						//           bit3: 1:o[XgTCNZNg2

	BSC.WSCR.BYTE=0x24;	// 0010 0100 bit5: 1:OԂ8 rbgANZX
						//           bit4: 1:OԃANZX3 Xe[gANZX
						//           bit3-2: EFCg[hZNg 01:EFCg֎~
						//           bit1-0: EFCgJEg
	  
/*
	BSC.BCR.BIT.ICIS0=1;		// AChTCN}Ȃ
	BSC.BCR.BIT.BRSTRM=0;		// {oXC^[tF[X
	BSC.WSCR.BIT.ABW=1;		// 8rbgoX
	BSC.WSCR.BIT.AST=0;		// 2Xe[gANZX
	BSC.WSCR.BIT.WMS=0;		// EFCg[h EGCgȂ
	BSC.WSCR.BIT.WC=0;		// vOEFCg
*/
  	P1.DDR=0xff;		//  A0- A7 o
  	P2.DDR=0xff;		//  A8-A15 o
	PA.EQU.DDR=0xff;	// A16-A23 o
	
	SYSCR.BYTE=0x09;		// 0000 1001 荞݃[h0 RAML 
	INTC.ICRA.BYTE=0x00;	// 荞ݗD惌x D悵݂BIT1ɂ
	INTC.ICRB.BYTE=0x00;
	INTC.ICRC.BYTE=0x00;
	
	//INTC.ICRB.BIT._TMR0=1;	// TMR0 荞ݍŗD READ DATA o
	INTC.ICRC.BIT._SCI2=1;	// SCI2 荞ݍŗD READ DATA o
	
	MSTPCR.WORD=0xFFFF;	// ӂׂăW[Xgbv
	SBYCR.BYTE=0x00;	// CPUNbN[hiȂj
	LPWRCR.BYTE=0x00;	// TuNbNȂ
}

__inline void DI(void)
{
	set_imask_ccr((_UBYTE)1);	// 荞݋֎~
}

__inline void EI(void)
{
	set_imask_ccr((_UBYTE)0);	// 荞݋
}