/*
D88`̃C[Wt@Cǂݏ
fBXNC[WǂŃgbNobt@1gbN

2014N1020	OSŃt@C̃[hł悤ɂȂIPLNłȂ
2014N1019	CRČvZŃAhX}[NAf[^}[N܂߂̂YĂ̂𒼂B
2014N94쐬
*/

#include "ff.h"
#include "fd.h"
#include "iodefine.h"
#include "hardware.h"
#include "xprintf.h"

__inline void d88_read_sectheader(void)
{
	unsigned int readcount;
	
	res=f_read(&file, &d88sect.c, 1, &readcount);
	res=f_read(&file, &d88sect.h, 1, &readcount);
	res=f_read(&file, &d88sect.r, 1, &readcount);
	res=f_read(&file, &d88sect.n, 1, &readcount);
	read_short(&d88sect.sect);
	res=f_read(&file, &d88sect.density, 1, &readcount);
	res=f_read(&file, &d88sect.deleted, 1, &readcount);
	res=f_read(&file, &d88sect.status,  1, &readcount);
	res=f_read(&file, &d88sect.reserve, 5, &readcount);
	read_short(&d88sect.size);
	
	///////////////////////////////////////////////////////////////////////////////////
	//xprintf("C:%d H:%d R:%d N:%d / %d sect/track %d byte/sect\n"
	//	,d88sect.c,d88sect.h,d88sect.r,d88sect.n,d88sect.sect,d88sect.size);

}

__inline void d88_trackread(void)
{
	trbuff.updated=0;	// XVSTEP荞݂updated1ɂȂIčXV

	/*
	if(1==DIRECTION_SELECT) xputs("D1");	//1(H):ֈړ
	else xputs("D0");
	*/
	
	res=f_open(&file,trbuff.filename,FA_READ|FA_OPEN_EXISTING);	// ̃t@C[hI[

	if(FR_OK==res)
	{
		// gbÑf[^gbNobt@ɓWJ
		unsigned long offset;
		unsigned int readcount;
		unsigned short sectcount;
		unsigned char side;
				
		if(0==SIDEONE_SELECT) side=1; else side=0;	// SIDEONE SELECT   H:SIDE0 / L:SIDE1

		offset=d88idx.track_offset[(trbuff.cylinder * 2) + side];

		f_lseek(&file,offset);	// IꂽgbN̐擪ɃV[N


		mfm_reset();	// mfmGR[_Zbg
				
		// vAu
		trbuff.wpos=0;	// gbNobt@擪
		track_buff_wMFM(0x4E, 80);	// GAP0
		track_buff_wMFM(0x00, 12);	// SYNC
		track_buff_wMMC(0xC2,  3);	// (C2) missing clock
		track_buff_wMFM(0xFC,  1);	// IAM
		track_buff_wMFM(0x4E, 50);	// GAP1
						
		d88sect.sect=1;
		for(sectcount=0; sectcount!=d88sect.sect; sectcount++)	// ZN^[JԂ
		{
			// ZN^[
			unsigned short crc,count;
			
			if(sectcount==35) break;	// C[Wt@C̃f[^ĂĂő35ZN^ŏI
			
			d88_read_sectheader();	// C[Wt@CZN^̃wb_ǂ
			
			if(FR_OK!=res) break;	// [hG[ (res̓O[o)
					
			track_buff_wMFM(0x00, 12);	// SYNC
			track_buff_wMMC(0xA1,  3);	// (A1) missing clock
			track_buff_wMFM(0xFE,  1);	// IDAM
						
			crc = 0xffff;	// CRCl
			crc = crc_1byte(0xA1, crc);
			crc = crc_1byte(0xA1, crc);
			crc = crc_1byte(0xA1, crc);
			crc = crc_1byte(0xFE, crc);
			
			track_buff_wMFM(d88sect.c,   1);	// C
			crc = crc_1byte(d88sect.c, crc);
			track_buff_wMFM(d88sect.h,   1);	// H
			crc = crc_1byte(d88sect.h, crc);
			track_buff_wMFM(d88sect.r,   1);	// R
			crc = crc_1byte(d88sect.r, crc);
			track_buff_wMFM(d88sect.n,   1);	// N
			crc = crc_1byte(d88sect.n, crc);
			track_buff_wMFM((crc >> 8) & 0xFF, 1);	// CRC H
			track_buff_wMFM(crc & 0x00FF, 1);		// CRC L
			track_buff_wMFM(0x4E, 22);	// GAP2
			track_buff_wMFM(0x00, 12);	// SYNC

			track_buff_wMMC(0xA1,  3);	// (A1) missing clock

			crc = 0xffff;	// CRCl
			crc = crc_1byte(0xA1, crc);
			crc = crc_1byte(0xA1, crc);
			crc = crc_1byte(0xA1, crc);
		
			if(0x00==d88sect.deleted)
			{
				track_buff_wMFM(0xFB, 1);	// DATA MARK
				crc = crc_1byte(0xFB, crc);
			}
			else
			{
				track_buff_wMFM(0xF8, 1);	// DELETED DATA MARK
				crc = crc_1byte(0xF8, crc);
			}
			
			// 1ZN^DATA
			for(count=d88sect.size; 0!=count; count--)
			{
				unsigned char data;
				if(0!=trbuff.updated) goto Interruption;	// SETPM荞݂璆f
							
				res=f_read(&file, &data, 1, &readcount);
				track_buff_wMFM(data, 1);
				crc = crc_1byte(data, crc);
			}
			// CRC
			track_buff_wMFM((crc >> 8) & 0xFF, 1);	// CRC H
			track_buff_wMFM(crc & 0x00FF, 1);		// CRC L
			
			// GAP3
			{
				unsigned char count;
				switch(d88sect.n)
				{
					case SECT_CAPACITY128:
						count=42;	// 128byte/secter
						break;
					case SECT_CAPACITY256:
						count=54;	// 256byte/secter
						break;
					case SECT_CAPACITY512:
						count=84;	// 512byte/secter
						break;
					default:
						count=116;	// 1024byte/secter
						break;
				}
				track_buff_wMFM(0x4E, count);
			}
		}
				
		// GAP4
		if((0x20==d88idx.type)&&(0x36==status.rpm))	// 2HD 360RPM
		{
			if(TRACK_LENGTH_360RPM_250KBPS < (trbuff.wpos+100))	// f[^񂠂300RPM
			{
				trbuff.length=TRACK_LENGTH_300RPM_500KBPS;
				status.rpm=0x30;
			}
		}
				
		// GAP4 ŃgbN̏I܂Ŗ߂
		{
			unsigned short count;
			count=trbuff.length-trbuff.wpos;
			count>>=1;	// 1/2
			track_buff_wMFM(0x4E, count);
		}
	}
			
	Interruption:
	//////////////////////////////////////////////////////////////////////////////////

	f_close(&file);
	//trbuff.rpos=0;
	
	//xprintf("C%d\n",trbuff.cylinder);
}