/*
2014N827쐬
*/
#include "ff.h"

#define BITRATE_500	4	// NbÑ݂rbg[g 4:1Mbps 9:500kbps 19:250kbps
#define BITRATE_250	9
#define BITRATE_125	19

#define INDEX_W500	375	// 500kbps / pX3000us/8rbg̎ԁiNbNrbg݁j8us=375
#define INDEX_W250	188	// 250kbps / 3000/16=188
#define INDEX_W125	94	// 125kbps / 3000/32=94

#define TRACK_LENGTH_300RPM_500KBPS	25000	// 300RPM 500kbps AtH[}bg2MB (2HD 1.44MB)
// 1/300rpm*60s*1000ms=200ms 鎞
// 1000000bps/1000ms*200ms=200000bit ̃rbgiNbNrbg݁j
// 200000bit/8=25000byte ̃oCg

#define TRACK_LENGTH_360RPM_500KBPS	20834	// 360RPM 500kbps AtH[}bg1.6MB (2HD 1.2MB)
// 1/360rpm*60s*1000ms=166.67ms
// 1000000bps/1000ms*166.67ms=166667bit
// 166667bit/8=20834byte

#define TRACK_LENGTH_300RPM_250KBPS	12500	// 300RPM 250kbps	2D/2DDʁi2D/2DD̈Ⴂ̓gbNj
#define TRACK_LENGTH_360RPM_250KBPS	10417	// 360RPM 250kbps	2D/2DD

#define TRACK_MAX_2HD	81	// 0-79 80 track
#define TRACK_MAX_2DD	81
#define TRACK_MAX_2D	40	// 0-39 40 track

#define read_data_stop()	SCI2.SCR.BYTE=0x00	// M֎~ SCI荞݋֎~

#define SECT_CAPACITY128	0
#define SECT_CAPACITY256	1
#define SECT_CAPACITY512	2
#define SECT_CAPACITY1024	3
#define SECT_CAPACITY2048	4
#define SECT_CAPACITY4096	5
#define SECT_CAPACITY8192	6

#define MEDIA_2D	0x00
#define MEDIA_2DD	0x10
#define MEDIA_2HD	0x20
#define MEDIA_EMPTY	0xFF

struct st_fd_status
{
	unsigned char media;			// 0xFF: 0x00:2D 0x10:2DD 0x20:2HD
	unsigned char rpm;				// 0x30:300RPM 0x36:360RPM
	unsigned char write_protect;	// 0x10:CgveNgL 0x00:
	unsigned char disk_change;		// ZbgƃfBXN`FWŃZbg
									// fBXNĂăXebvpX󂯂NA
	unsigned char selected;			// hCuZNgĂ
};

struct st_track_buffer
{
	char filename[14];
	unsigned char buff[25000];
	unsigned short length;
	unsigned short rpos;
	unsigned short wpos;
	unsigned short index_width;
	unsigned char cylinder;
	unsigned char cylinder_max;
	unsigned char updated;	// gbNXVꂽ̃tO
};

struct st_d88_header
{
	char name[17];						// +0x00 fBXNC[W̖O I[\0܂
	char reserve[9];					// +0x11 \
	unsigned char write_protect;		// +0x1A 0x10:CgveNgL 0x00:
	unsigned char type;					// +0x1B 0x00:2D 0x10:2DD 0x20:2HD
	unsigned long size;					// +0x1C C[WTCỸTCY+1ioCg gGfBAj
										//       ̃C[Wւ̃ItZbg
	unsigned long track_offset[164];	// +0x20 C[Wt@C擪̃ItZbg
										//       ݂ȂgbN 0
};

struct st_d88_sect_header
{
	unsigned char c;			// +0x00 V_ԍ
	unsigned char h;			// +0x01 wbhiSIDEjԍ
	unsigned char r;			// +0x02 ZN^ԍ (擪ZN^1)
	unsigned char n;			// +0x03 ZN^R[h@0x00:128
								//                       0x01:256
								//                       0x02:512
								//                       0x03:1024
								//                       0x04:2048
								//                       0x05:4096
								//                       0x06:8192
	unsigned short sect;		// +0x04 ̃gbÑZN^
	unsigned char density;		// +0x06 L^x 0x00:MFM 0x40:FM
	unsigned char deleted;		// +0x07 0x00:DAM (NORMAL) 0x10:DDAM (DELETED)
	unsigned char status;		// +0x08 0x00:G[
								//       0x10:G[ DDAMo
								//       0xA0:ID CRCG[
								//       0xB0:DATA CRCG[
								//       0xE0:IDAMȂ
								//       0xF0:DAMȂ
	unsigned char reserve[5];	// +0x09 \
	unsigned short size;		// +0x0E ZN^f[^̃TCYĩwb_͊܂܂Ȃj
								// +0x10 ZN^f[^
};

extern FATFS	fs;
extern FIL		file;
extern FRESULT	res;
extern DIR		dir;
extern FILINFO	finfo;

extern volatile struct st_fd_status			status;
extern volatile struct st_d88_header		d88idx;
extern volatile struct st_d88_sect_header	d88sect;
extern volatile struct st_track_buffer		trbuff;
//extern volatile unsigned char TRACK_BUFF[];
