/*
gbNobt@FMGR[hŏ

2014N94쐬
*/

#include "ff.h"
#include "fd.h"

const unsigned char FM_TABLE[16]=
/*
10101010  AA
10101011  AB
10101110  AE
10101111  AF
10111010  BA
10111011  BB
10111110  BE
10111111  BF
11101010  EA
11101011  EB
11101110  EE
11101111  EF
11111010  FA
11111011  FB
11111110  FE
11111111  FF
*/
{
	0xAA, 0xAB, 0xAE, 0xAF, 0xBA, 0xBB, 0xBE, 0xBF, 
	0xEA, 0xEB, 0xEE, 0xEF, 0xFA, 0xFB, 0xFE, 0xFF 
};

unsigned short fm(unsigned char data)
{
	unsigned short ret;
	
	ret =(unsigned short)(FM_TABLE[(data >> 4) & 0x0F]) << 8;
	ret+=FM_TABLE[data & 0x0F];
	return ret;
}

/*
FM ŃgbNobt@[ data  length 
݃|C^XV
*/
void track_buff_wFM(unsigned char data, unsigned short length)
{
	unsigned short out;
	
	out=fm(data);

	for( ; 0!=length; length--)
	{
		if(trbuff.wpos > (trbuff.length - 2)) break;
		trbuff.buff[trbuff.wpos]=(out>>8) & 0xFF;
		trbuff.wpos++;
		trbuff.buff[trbuff.wpos]=out & 0xFF;
		trbuff.wpos++;
	}
}

// FM ̃~bVONbN
void track_buff_wFMM(unsigned char data)	
{
	switch(data)
	{
		case 0xF8:
			//  data 0xF8  1 1  1 1  1 0  0 0
			// clock 0xC7 1 1  0 0  0 1  1 1
			//                 x x  x    - missing
			//   out      1111 0101 0110 1010 = 0xF56A
			trbuff.buff[trbuff.wpos]=0xF5;
			trbuff.wpos++;
			trbuff.buff[trbuff.wpos]=0x6A;
			trbuff.wpos++;
			break;
		case 0xF9:
			//  data 0xF9  1 1  1 1  1 0  0 1
			// clock 0xC7 1 1  0 0  0 1  1 1
			//                 x x  x    - missing
			//   out      1111 0101 0110 1011 = 0xF56B
			trbuff.buff[trbuff.wpos]=0xF5;
			trbuff.wpos++;
			trbuff.buff[trbuff.wpos]=0x6B;
			trbuff.wpos++;
			break;
		case 0xFA:
			//  data 0xFA  1 1  1 1  1 0  1 0
			// clock 0xC7 1 1  0 0  0 1  1 1
			//                 x x  x    - missing
			//   out      1111 0101 0110 1110 = 0xF56E
			trbuff.buff[trbuff.wpos]=0xF5;
			trbuff.wpos++;
			trbuff.buff[trbuff.wpos]=0x6E;
			trbuff.wpos++;
			break;
		case 0xFB:
			//  data 0xFB  1 1  1 1  1 0  1 1
			// clock 0xC7 1 1  0 0  0 1  1 1
			//                 x x  x    - missing
			//   out      1111 0101 0110 1111 = 0xF56F
			trbuff.buff[trbuff.wpos]=0xF5;
			trbuff.wpos++;
			trbuff.buff[trbuff.wpos]=0x6F;
			trbuff.wpos++;
			break;
		case 0xFC:
			//  data 0xFC  1 1  1 1  1 1  0 0
			// clock 0xD7 1 1  0 1  0 1  1 1	// FCNbNp^[Ⴄ
			//                 x    x    - missing
			//   out      1111 0111 0111 1010 = 0xF77A
			trbuff.buff[trbuff.wpos]=0xF7;
			trbuff.wpos++;
			trbuff.buff[trbuff.wpos]=0x7A;
			trbuff.wpos++;
			break;
		case 0xFE:
			//  data 0xF8  1 1  1 1  1 1  1 0
			// clock 0xC7 1 1  0 0  0 1  1 1
			//                 x x  x    - missing
			//   out      1111 0101 0111 1110 = 0xF57E
			trbuff.buff[trbuff.wpos]=0xF5;
			trbuff.wpos++;
			trbuff.buff[trbuff.wpos]=0x7E;
			trbuff.wpos++;
			break;
		default:
			track_buff_wFM(data, 1);	// ʏFMGR[hŏ
			break;
	}
}
