/*
2014N827쐬
2014N830xprintf悤ɂȂBgĂ{[hsǂij
2014N831fatfsBd88C[W̃wb_ǂ߂悤ɂȂB
*/
#include "iodefine.h"
#include "uart.h"
#include "xprintf.h"
#include "ff.h"
#include "fd.h"

char Line[80];	// L[͗pobt@

void puthelp(void)
{
	xputs("TEST MONITOR\n");
	xputs("command\n");
	xputs("f          : files\n");
	xputs("d filename : dump\n");
	xputs("tb offset   : track buff dump (bin)\n");
	xputs("tx offset   : track buff dump (hex)\n");
	xputs("m filename : mount\n");
	xputs("u          : unmount\n");
}

void monitor_init(void)
{
	// xprintfɓo͊֐ݒ
	xdev_in(getch);
	xdev_out(putch);

	xputs("\n");
	puthelp();
	xputs(">");
}

void put_rc (FRESULT rc)
{
	const char *str =
		"OK\0" "DISK_ERR\0" "INT_ERR\0" "NOT_READY\0" "NO_FILE\0" "NO_PATH\0"
		"INVALID_NAME\0" "DENIED\0" "EXIST\0" "INVALID_OBJECT\0" "WRITE_PROTECTED\0"
		"INVALID_DRIVE\0" "NOT_ENABLED\0" "NO_FILE_SYSTEM\0" "MKFS_ABORTED\0" "TIMEOUT\0"
		"LOCKED\0" "NOT_ENOUGH_CORE\0" "TOO_MANY_OPEN_FILES\0";
	FRESULT i;

	for (i = 0; i != rc && *str; i++) {
		while (*str++) ;
	}
	xprintf("rc=%u FR_%s\n", (UINT)rc, str);
}

void files(void)
{
	f_mount(&fs, "", 0);
	f_chdir("/");
	res=f_opendir(&dir,"");
	
	if(FR_OK==res)
	{
		while(1)	// [gfBNg̃t@Cꗗ\
		{
			res=f_readdir(&dir,&finfo);
			if(FR_OK!=res) break;
			if(finfo.fname[0]==0) break;
			xprintf("%s\n",finfo.fname);
		}
	}
	
	if(FR_OK!=res) put_rc(res);	// G[\
}

//  in  n Ԗڂ̍ڂ  out Ɏo
// Zp[^ ' '  ','
signed char getstr(
	char in[],
	unsigned char n,	
	char out[],
	unsigned char size)	// out̃TCY
{
	unsigned char pos,a,b;
	
	if(0==n) n=1;
	pos=0;
	while(1)
	{
		// Zp[^ǂݔ΂
		while(1)
		{
			if(0==in[pos]) return -1;	// I[܂ŗُI
			if((' '!=in[pos])&&(','!=in[pos])) break;
			pos++;
		}
		if(1==n) break;

		// Zp[^ȊOǂݔ΂
		while(1)
		{
			if(0==in[pos]) return -1;	// I[܂ŗُI
			if((' '==in[pos])||(','==in[pos])) break;
			pos++;
		}
		n--;
	}
	
	for(a=0; a!=(size-1); a++)
	{
		out[a]=0;
		if((' '==in[pos])||(','==in[pos])) break;
		out[a]=in[pos];
		pos++;
	}
	out[size-1]=0;

	return 0;
}

void dump()
{
	char filename[13];
	unsigned int a,b;
	unsigned char buff[16];

	getstr(Line,2,filename,sizeof filename);
		
	xprintf("%s\n",filename);
	
	f_mount(&fs, "", 0);
	res=f_open(&file,filename,FA_READ|FA_OPEN_EXISTING);	// ̃t@C[hI[

	if(FR_OK==res)
	{
		for(a=0; 7!=a; a++)
		{
			res=f_read(&file, &buff, 16, &b);	// t@C16oCgǂ b:ۂɓǂ߂oCg
			put_dump(&buff, a*16, b, DW_CHAR);	// ǂ߂oCi_v
		}
	}
	f_close(&file);

	if(FR_OK!=res) put_rc(res);	// G[\
}
/*
unsigned short short_cnv(unsigned short a)
{
	unsigned short ret;
	ret =(a & 0x00ff) << 8;
	ret+=(a & 0xff00) >> 8;
	return ret;
}

unsigned long long_cnv(unsigned long a)
{
	unsigned long ret;
	ret =(a & 0x000000ff) << 24;
	ret+=(a & 0x0000ff00) << 8;
	ret+=(a & 0x00ff0000) >> 8;
	ret+=(a & 0xff000000) >> 24;
	return ret;
}
*/

unsigned char read_1byte(void* out)
{
	unsigned int readcount;
	res=f_read(&file, &out, 1, &readcount);
	return readcount;
}

unsigned char read_long(unsigned long* out)
{
	unsigned int readcount;
	unsigned char buff[4];
	
	res=f_read(&file, &buff, 4, &readcount);
	
	*out = ((unsigned long)buff[0] <<  0)
	      +((unsigned long)buff[1] <<  8)
	      +((unsigned long)buff[2] << 16)
	      +((unsigned long)buff[3] << 24);
	return readcount;
}

unsigned char read_short(unsigned short* out)
{
	unsigned int readcount;
	unsigned char buff[2];
	
	res=f_read(&file, &buff, 2, &readcount);
	
	*out = ((unsigned short)buff[0] <<  0)
	      +((unsigned short)buff[1] <<  8);
	return readcount;
}

void unmount(void)
{
	status.media=0xFF;		// hCu
	status.disk_change=1;	// fBXN`FW
	status.selected=0;
	io_init();
}

void mount(void)
{
	unsigned int a,b;
	unsigned char buff[16];
	
	unmount();
	
	getstr(Line,2,trbuff.filename,sizeof trbuff.filename);
	xprintf("%s\n",trbuff.filename);
	
	f_mount(&fs, "", 0);
	res=f_open(&file,trbuff.filename,FA_READ|FA_OPEN_EXISTING);	// ̃t@C[hI[

	if(FR_OK==res)
	{
		// 
		// gGfBÃf[^rbOGfBAH8œǂނ̂ŁA1oCgÂǂ
		res=f_read(&file, &d88idx.name, 17, &b); d88idx.name[(sizeof d88idx.name)-1]=0;
		res=f_read(&file, &d88idx.reserve, 9, &b);
		//f_lseek(&file,0x1A);
		res=f_read(&file, &d88idx.write_protect, 1, &b);
		res=f_read(&file, &d88idx.type, 1, &b);
		//f_read(&file, &d88idx.size, 4, &b);
		read_long(&d88idx.size);
		//res=f_read(&file, &d88idx.track_offset[0], 164*4, &b);
		//if((164*4)!=b) xprintf("ILLEGAN IMAGE FILE\n");	// f[^Ȃ
		for(a=0; a!=164; a++)
		{
			read_long(&d88idx.track_offset[a]);
		}
	}

	if(FR_OK!=res)
	{
		put_rc(res);	// G[\
		
		status.media=0xFF;	// 
	}
	else
	{
		// G[Ȃ	
		status.media=d88idx.type;

		fd_init(status.media);

		{
			// gbN܂Ńf[^邩ׂ
			unsigned char a;
			for(a=0; a!=164; a++)
			{
				if(0==d88idx.track_offset[a])
				  if((163!=a)&&(0==d88idx.track_offset[a+1])) break;	// 20
			}
			//a--;
			trbuff.cylinder_max=a/2-1;
		}
		
		switch(d88idx.type)
		{
			case MEDIA_2D:	// 2D
				trbuff.index_width=INDEX_W250;	// INDEXM̃pXݒ
				trbuff.length=TRACK_LENGTH_300RPM_250KBPS;
				status.rpm=0x30;	// 2D2DD͑S300RPM
				break;
			case MEDIA_2DD:	// 2DD
				trbuff.index_width=INDEX_W250;
				trbuff.length=TRACK_LENGTH_300RPM_250KBPS;
				status.rpm=0x30;	// 2D2DD͑S300RPM
				break;
			case MEDIA_2HD:	// 2HD
				trbuff.index_width=INDEX_W500;
				trbuff.length=TRACK_LENGTH_360RPM_500KBPS;
				status.rpm=0x36;	// Ƃ肠360RPM
				break;
			default:
				trbuff.index_width=INDEX_W500;
				trbuff.length=TRACK_LENGTH_300RPM_500KBPS;
				status.rpm=0x30;
				break;
		}
		trbuff.cylinder=4;	//gbN̏l
		trbuff.updated=1;
		trbuff.wpos=0;
		trbuff.rpos=0;


		xprintf("NAME         :%s\n",d88idx.name);
		xprintf("WRITE PROTECT:0x%02x ",d88idx.write_protect);
		switch(d88idx.write_protect)
		{
			case 0x00:
				xputs("OFF\n");
				break;
			case 0x10:
				xputs("ON\n");
				break;
			default:
				xputs("?\n");
				break;
		}
		xprintf("DISK TYPE    :0x%02x ",d88idx.type);
		switch(d88idx.type)
		{
			case MEDIA_2D:
				xputs("2D ");
				break;
			case MEDIA_2DD:
				xputs("2DD ");
				break;
			case MEDIA_2HD:
				xputs("2HD ");
				break;
			default:
				xputs("? ");
				break;
		}
		xprintf("%d CYLINDER\n",trbuff.cylinder_max+1);	// gbNԍ0
		xprintf("SIZE         :%ld (0x%08LX) BYTE\n", d88idx.size, d88idx.size);
		for(a=0; a!=4; a++)
		{
			xprintf("TRACK OFFSET[%d] 0x%08LX\n",a,d88idx.track_offset[a]);
		}
	}
	f_close(&file);
	
	status.disk_change=1;	// słłDISK CHANGEZbg
}

void trackdump(void)
{
	char *ptr;
	static long offset=0;
	long in;
	unsigned short pos;
	
	ptr = Line;	
	*ptr++;
	*ptr++;
	if(0!=xatoi(&ptr,&in)) offset=in;

	switch(Line[1])
	{
		case 'b':
			xprintf("%ld ",offset);
			for(pos=0; 8!=pos; pos++)
			{
				xprintf("%08b ",trbuff.buff[offset]);
				offset++;
			}
			xputs("\n");
			break;
		case 'x':
			put_dump(&trbuff.buff[offset],offset,16,DW_CHAR);
			offset+=16;
			break;
	}
}

void monitor(void)
{
	if(0!=keyhit())	// L[͂
	{
		xgets(Line, sizeof Line);	// 1s
		switch(Line[0])
		{
			case 'f':
				files();
				break;
			case 'd':
				dump();
				break;
			case 'm':
				mount();
				break;
			case 'u':
				unmount();
				xputs("UNMOUNTED\n");
				break;
			case 't':
				trackdump();
				break;
			default:
				puthelp();
				break;
		}
		
		xputs(">");
	}
}
